#ifndef INCL_SIGNALTOOLKIT
#define INCL_SIGNALTOOLKIT

namespace stk{		// signal tool kit
	
				//! tB^[p̒ۃNX
				/*!
					CFilter̓tB^[p֐̒ۃNXłB̃NX͎q
					߂̃C^[tF[Xpӂ܂B
					ΏۂƂȂtB^[͓1nAo1nłBf[^͔zƂ
					^܂̂ŁAftB^[ȂǂɊg邱ƂeՂɂł܂B
					o͂̓ubNĂ܂B܂A1Tvɏ\bh
					runĂԂ̂ł͂ȂACӂcount̃f[^܂Ƃ߂ď܂B
					ɂă\bhĂяoɕKvȒȃp[^Xgɂ
					I[o[wbh𑊑ΓIɌy܂B
				*/
	class CFilter{
	protected:
		short * h;				/*!< CpXłB
									CpX^z̓RXgN^
									ĂяoɃp[^[Ƃė^܂B
									CFilter͂̔zւ̃|C^hɊi[܂B
								*/
		short * delayline;		/*!< xiԕϐjłB
									xp̔z̓RXgN^̌ĂяoɓI
									mۂ܂B̂߁Aϐ̓|C^ƂĐ錾܂B
								*/
		short * curptr;			/*!< ݂̒x̃|C^łB
									̃|C^ delayline ̂ƂV
									f[^wBRXgN^ɂdelayline
									lɏ܂B
								*/
		int taps;				/*!< ^bvłB̕ϐ̓RXgN^Ăяoɂ
									܂B
								*/
	public:
		CFilter(	 			/*! RXgN^łB
									CFilter̃RXgN^͗^ꂽtaps̑傫
									zq[vɊmۂAdelaylineɑ܂B
									܂AcurptrdelaylineƓɂ܂BhɂcoeffInit
									܂B
								*/
			int taps, 			//!< ^bvw肵܂B
			short *coeffInit	//!< CpX̏l^܂B
			);
		virtual ~CFilter();		//!< fXgN^łBdelaylineJ܂B
		virtual void run( 		/*!< tB^[s֐łB
									
								*/
			short dst[],		/*!< o̓f[^ւ̃|C^łB̃|C^
									̓f[^̍ŏ̃f[^w܂B
								*/
			short src[],		/*!< ̓f[^ւ̃|C^łB̃|C^
									ŏ̏o̓f[^ꏊw܂B
								*/
			int count,			/*!< ̓f[^B
									܂Ƃ߂ĉ̃f[^邩w肵܂BȂׂ傫
									l^قI[o[wbhł܂B
								*/
			int dstStep=1,		/*!< o̓f[^̃XebviԊujłB
									Pʂ̓vZbT̃AhXPʂłBADSP-2191̏ꍇ[hłB
								*/
			int srcStep=1		/*!< ̓f[^̃XebviԊujB
									Pʂ̓vZbT̃AhXPʂłBADSP-2191̏ꍇ[hłB
								*/
			)=0;
	};	

	
				//! FIRtB^NX
				/*!
					CFirFilterFirtB^[pNXłB
				*/		
	class CFirFilter : public CFilter{
	public:
		CFirFilter( int aTaps, short * coeffInit )
				: CFilter( aTaps, coeffInit ){};	//*! RXgN^Bɉ܂B
		virtual void run( 		/*!< tB^[s֐łB
									
								*/
			short dst[],		/*!< o̓f[^ւ̃|C^łB̃|C^
									̓f[^̍ŏ̃f[^w܂B
								*/
			short src[],		/*!< ̓f[^ւ̃|C^łB̃|C^
									ŏ̏o̓f[^ꏊw܂B
								*/
			int count,			/*!< ̓f[^B
									܂Ƃ߂ĉ̃f[^邩w肵܂BȂׂ傫
									l^قI[o[wbhł܂B
								*/
			int dstStep=1,		/*!< o̓f[^̃XebviԊujłB
									Pʂ̓vZbT̃AhXPʂłBADSP-2191̏ꍇ[hłB
								*/
			int srcStep=1		/*!< ̓f[^̃XebviԊujB
									Pʂ̓vZbT̃AhXPʂłBADSP-2191̏ꍇ[hłB
								*/
			);
	};
	
	
	class CUpSampler : public CFilter{
	private:
		int ratio;
		int tapsDivRatio;
	public:
		CUpSampler(  			// RXgN^
			int taps,  			// ratio̐{łȂ΂ȂȂ
			short * coeffInit, 
			int ratio			// AbvTv L 
			);
		virtual void run( 		/*!< tB^[s֐łB
									
								*/
			short dst[],		/*!< o̓f[^ւ̃|C^łB̃|C^
									̓f[^̍ŏ̃f[^w܂B
								*/
			short src[],		/*!< ̓f[^ւ̃|C^łB̃|C^
									ŏ̏o̓f[^ꏊw܂B
								*/
			int count,			/*!< ̓f[^B
									܂Ƃ߂ĉ̃f[^邩w肵܂BȂׂ傫
									l^قI[o[wbhł܂B
								*/
			int dstStep=1,		/*!< o̓f[^̃XebviԊujłB
									Pʂ̓vZbT̃AhXPʂłBADSP-2191̏ꍇ[hłB
								*/
			int srcStep=1		/*!< ̓f[^̃XebviԊujB
									Pʂ̓vZbT̃AhXPʂłBADSP-2191̏ꍇ[hłB
								*/
			);

	};
	
	class CDownSampler : public CFilter{
	private:
		int ratio;
	public:
		CDownSampler(  			// RXgN^
			int taps,
			short * coeffInit, 
			int ratio			// _ETv M
			);
		virtual void run( 		/*!< tB^[s֐łB
									
								*/
			short dst[],		/*!< o̓f[^ւ̃|C^łB̃|C^
									̓f[^̍ŏ̃f[^w܂B
								*/
			short src[],		/*!< ̓f[^ւ̃|C^łB̃|C^
									ŏ̏o̓f[^ꏊw܂B
								*/
			int count,			/*!< ̓f[^B
									ratio̐{łȂ΂ȂȂB
									܂Ƃ߂ĉ̃f[^邩w肵܂BȂׂ傫
									l^قI[o[wbhł܂B
								*/
			int dstStep=1,		/*!< o̓f[^̃XebviԊujłB
									Pʂ̓vZbT̃AhXPʂłBADSP-2191̏ꍇ[hłB
								*/
			int srcStep=1		/*!< ̓f[^̃XebviԊujB
									Pʂ̓vZbT̃AhXPʂłBADSP-2191̏ꍇ[hłB
								*/
			);
			
	};	
	
// *************************************** IV[^[ ***************************************
			//@ׂĂDDS^̐cɂȂ钊ی^
	class COscillator {
	protected:
		int phase[4];		// phase͓ʑ(L,H)Ǝg(L,H)4[hȂ
							// ꂼ32bitŁAʑ̏16rbg\Ɏg
							// Ԃ͉ʂPL,PH,FL,FH
							// ʑ͕ȂŁA32bit2΂킷
							// g1TvƂ̈ʑip킷B
	public:
							// freq = ( 2^32 / Tvg ) * ړI̎g
		COscillator( int freqH, int freqL );
		virtual ~COscillator(){};
		virtual void setFreq( int freqH, int freqL );		// ʑ̋ύX
		virtual void setPhase( int phaseH, int phaseL );	// g̋ύX
		virtual void addFreq( int freqHDelta, int freqLDelta );
		virtual void addPhase( int phaseHDelta, int freqLDelta );
		virtual void run ( short sin[], int count, int step=1 )=0;
		virtual void run ( short sin[], short cos[], int count, int step=1 )=0;
	};

			// Op֐̉@ɂDDS
	class CSinCosDDS: public COscillator{
	public:
		CSinCosDDS( int freqH, int freqL ) : COscillator( freqH, freqL ){};
		virtual void run ( short sin[], int count, int step=1 );
		virtual void run ( short sin[], short cos[], int count, int step=1 );
	};

// *************************************** 񍀊֐ ***************************************

//		񍀎ZpZNX
//		
	class CFunction{
	public:
		virtual ~CFunction(){};
					// xNgԉZ
		virtual void run( short dst[], short src1[], short src2[], int count, 
							int dstStep=1, int src1Step=1, int src2Step=1 )=0;
					// xNgƃXJ[̊Ԃ̉Z
		virtual void run( short dst[], short src1[], int src2, int count, 
							int dstStep=1, int src1Step=1 );
		virtual void run( short dst[], int src1, short src2[], int count, 
							int dstStep=1, int src2Step=1 );
	};
	
					// Z
	class CMultiplier: public CFunction{
	public:
		virtual void run( short dst[], short src1[], short src2[], int count, 
							int dstStep=1, int src1Step=1, int src2Step=1 );
	};	
	
					// Z
	class CAdder: public CFunction{
	public:
		virtual void run( short dst[], short src1[], short src2[], int count, 
							int dstStep=1, int src1Step=1, int src2Step=1 );
	};	

					// Z
	class CSubtractor : public CFunction{
	public:				// src1-src2
		virtual void run( short dst[], short src1[], short src2[], int count, 
							int dstStep=1, int src1Step=1, int src2Step=1 );
	};	
	
					// 傫قƂ
	class CMax: public CFunction{
	public:
		virtual void run( short dst[], short src1[], short src2[], int count, 
							int dstStep=1, int src1Step=1, int src2Step=1 );
	};
	
					// قƂ
	class CMin: public CFunction{
	public:
		virtual void run( short dst[], short src1[], short src2[], int count, 
							int dstStep=1, int src1Step=1, int src2Step=1 );
	};		
	
					// 
	class CAverage: public CFunction{
	public:
		virtual void run( short dst[], short src1[], short src2[], int count, 
							int dstStep=1, int src1Step=1, int src2Step=1 );
	};		
};

#endif
